# ACAD - Adaptive Clustering and Anomaly Detection

ACAD is a Python library for adaptive clustering and anomaly detection, specifically designed for IoT network security in dynamic environments. It combines PCA, K-means clustering, and an adaptive isolation forest for effective anomaly detection.

## Features

- **PCA**: Dimensionality reduction using Principal Component Analysis.
- **K-means Clustering**: Grouping data into clusters using MiniBatchKMeans for incremental updates.
- **Adaptive Isolation Forest**: Detecting anomalies and outliers.
- **Anomaly Detection**: Integrates PCA, K-means, and Isolation Forest for comprehensive anomaly detection.
- **Real-time Anomaly Detection**: Supports processing streaming data for real-time anomaly detection.

## Installation

```bash
pip install acad
